:::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: This cmd file preps the hard drive for restoring a
:: new base OS by removing all partitions except SP
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::

@ECHO OFF

:: Delete all partitions excpet the SP
:: Assume that if there is a SP, then it is located at the end of the drive

SET DELALLDISK=0
IF NOT "%1" == "" SET DELALLDISK=%1

ECHO import os, sys, time, string>%RAMD%\DELALL.PY
ECHO import iudeploy>>%RAMD%\DELALL.PY
ECHO import deputils>>%RAMD%\DELALL.PY
ECHO import iubutils>>%RAMD%\DELALL.PY
ECHO import ndisk>>%RAMD%\DELALL.PY
ECHO import nlslocal>>%RAMD%\DELALL.PY

ECHO def FindSPnum(tryDiskpart = True, useDriveLetter = None):>>%RAMD%\DELALL.PY
ECHO     script = open(iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'VOLUMES.SCP'), 'w+')>>%RAMD%\DELALL.PY
ECHO     script.write('LIST VOLUME' + os.linesep)>>%RAMD%\DELALL.PY
ECHO     script.write('EXIT' + os.linesep)>>%RAMD%\DELALL.PY
ECHO     script.close()>>%RAMD%\DELALL.PY
ECHO     iubutils.log(_(u'Running diskpart to list all volumes'))>>%RAMD%\DELALL.PY
ECHO     volumes = os.popen('diskpart /s ' + iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'VOLUMES.SCP'))>>%RAMD%\DELALL.PY
ECHO     sp_vol_num = -1>>%RAMD%\DELALL.PY
ECHO     if volumes:>>%RAMD%\DELALL.PY
ECHO         try:>>%RAMD%\DELALL.PY
ECHO             splabels = iudeploy.getSPLabels()>>%RAMD%\DELALL.PY
ECHO         except:>>%RAMD%\DELALL.PY
ECHO         #Change for Vista>>%RAMD%\DELALL.PY
ECHO             splabels = ['IBM_SERVICE', 'SERVICEV001', 'SERVICEV002']>>%RAMD%\DELALL.PY
ECHO         line=volumes.readline()>>%RAMD%\DELALL.PY
ECHO         while (line):>>%RAMD%\DELALL.PY
ECHO             for label in splabels:>>%RAMD%\DELALL.PY
ECHO                 if string.upper(line).find(label) != -1:>>%RAMD%\DELALL.PY
ECHO                     line2 = string.split(line)>>%RAMD%\DELALL.PY
ECHO                     if len(line2):>>%RAMD%\DELALL.PY
ECHO                         try:>>%RAMD%\DELALL.PY
ECHO                             sp_vol_num = int(line2[1])>>%RAMD%\DELALL.PY
ECHO                             break>>%RAMD%\DELALL.PY
ECHO                         except:>>%RAMD%\DELALL.PY
ECHO                             pass>>%RAMD%\DELALL.PY
ECHO             line=volumes.readline()>>%RAMD%\DELALL.PY
ECHO     volumes.close()>>%RAMD%\DELALL.PY
ECHO     try: >>%RAMD%\DELALL.PY
ECHO         disknum = ndisk.getNonUSBDriveNumPy(0)>>%RAMD%\DELALL.PY
ECHO     except: >>%RAMD%\DELALL.PY
ECHO         disknum = 0 >>%RAMD%\DELALL.PY
ECHO     script = open(iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DETAILS.SCP'), 'w+')>>%RAMD%\DELALL.PY
ECHO     script.write('SELECT DISK '+ str(disknum) + os.linesep)>>%RAMD%\DELALL.PY
ECHO     script.write('SELECT VOLUME ' + str(sp_vol_num) + os.linesep)>>%RAMD%\DELALL.PY
ECHO     script.write('DETAIL PARTITION ' + os.linesep)>>%RAMD%\DELALL.PY
ECHO     script.write('EXIT' + os.linesep)>>%RAMD%\DELALL.PY
ECHO     script.close()>>%RAMD%\DELALL.PY
ECHO     iubutils.log(_(u'Running diskpart to detail partitions'))>>%RAMD%\DELALL.PY
ECHO     partitions = os.popen('diskpart /s ' + iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DETAILS.SCP'))>>%RAMD%\DELALL.PY
ECHO     sp_par_num = -1>>%RAMD%\DELALL.PY
ECHO     if partitions:>>%RAMD%\DELALL.PY
ECHO         line=partitions.readline()>>%RAMD%\DELALL.PY
ECHO         while (line):>>%RAMD%\DELALL.PY
ECHO            line2 = string.split(line)>>%RAMD%\DELALL.PY
ECHO            if (-1 == sp_par_num) and (len(line2) ==2):>>%RAMD%\DELALL.PY
ECHO                try:>>%RAMD%\DELALL.PY
ECHO                    sp_par_num = int(line2[1])>>%RAMD%\DELALL.PY
ECHO                    break>>%RAMD%\DELALL.PY
ECHO                except:>>%RAMD%\DELALL.PY
ECHO                    pass>>%RAMD%\DELALL.PY
ECHO            line=partitions.readline()>>%RAMD%\DELALL.PY
ECHO         partitions.close()>>%RAMD%\DELALL.PY
ECHO     return sp_par_num>>%RAMD%\DELALL.PY

ECHO spdrive=deputils.FindSP()>>%RAMD%\DELALL.PY
ECHO sp_num = -1>>%RAMD%\DELALL.PY
ECHO try: >>%RAMD%\DELALL.PY
ECHO   disknum = ndisk.getNonUSBDriveNumPy(0)>>%RAMD%\DELALL.PY
ECHO except: >>%RAMD%\DELALL.PY
ECHO   disknum = 0 >>%RAMD%\DELALL.PY
ECHO script = open(iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DELALL.SCP'), 'w+')>>%RAMD%\DELALL.PY
ECHO script.write('SELECT DISK ' + str(disknum) + os.linesep)>>%RAMD%\DELALL.PY
ECHO if not spdrive:>>%RAMD%\DELALL.PY
ECHO   iubutils.log('Delete All - No SP found, clean drive', 'stamp.log')>>%RAMD%\DELALL.PY
ECHO   script.write('CLEAN' + os.linesep)>>%RAMD%\DELALL.PY
ECHO   partition_num = 1 >>%RAMD%\DELALL.PY
ECHO else:>>%RAMD%\DELALL.PY
ECHO   sp_num = FindSPnum()>>%RAMD%\DELALL.PY
ECHO   try: >>%RAMD%\DELALL.PY
ECHO     partition_num = iudeploy.getNumPartitions(disknum)>>%RAMD%\DELALL.PY
ECHO   except: >>%RAMD%\DELALL.PY
ECHO     partition_num = ndisk.getNumPartitionsPy(disknum)>>%RAMD%\DELALL.PY
ECHO   iubutils.log('Delete All - SP found, total number of partitions = ' + str(partition_num) + ' sp: ' + str(sp_num), 'stamp.log')>>%RAMD%\DELALL.PY
ECHO   delnum = partition_num>>%RAMD%\DELALL.PY
ECHO   while (delnum): >>%RAMD%\DELALL.PY
ECHO     if not delnum-1 == sp_num:>>%RAMD%\DELALL.PY
ECHO       script.write('SELECT PARTITION ' + str(delnum-1) + os.linesep)>>%RAMD%\DELALL.PY
ECHO       script.write('DELETE PARTITION OVERRIDE NOERR' + os.linesep)>>%RAMD%\DELALL.PY
ECHO     delnum = delnum - 1 >>%RAMD%\DELALL.PY
ECHO script.write('EXIT' + os.linesep)>>%RAMD%\DELALL.PY
ECHO script.close()>>%RAMD%\DELALL.PY

ECHO script = open(iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DELALLN.SCP'), 'w+')>>%RAMD%\DELALL.PY
ECHO script.write('SELECT DISK ' + str(disknum) + os.linesep)>>%RAMD%\DELALL.PY
ECHO delnum = partition_num>>%RAMD%\DELALL.PY
ECHO script.write('SELECT PARTITION ' + str(delnum) + os.linesep)>>%RAMD%\DELALL.PY
ECHO script.write('DELETE PARTITION OVERRIDE NOERR' + os.linesep)>>%RAMD%\DELALL.PY
ECHO script.write('EXIT' + os.linesep)>>%RAMD%\DELALL.PY
ECHO script.close()>>%RAMD%\DELALL.PY
ECHO if partition_num and (sp_num != delnum):>>%RAMD%\DELALL.PY
ECHO   iudeploy.spawn('diskpart', '/s ' + iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DELALLN.SCP'), string.strip(os.getenv('RAMD', 'Z:')), True, False)>>%RAMD%\DELALL.PY

ECHO if partition_num:>>%RAMD%\DELALL.PY
ECHO   iubutils.log('Delete All - Running diskpart to delete all partitions')>>%RAMD%\DELALL.PY
ECHO   iudeploy.spawn('diskpart', '/s ' + iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DELALL.SCP'), string.strip(os.getenv('RAMD', 'Z:')), True, False)>>%RAMD%\DELALL.PY

ECHO time.sleep(5)>>%RAMD%\DELALL.PY
ECHO if not spdrive: sys.exit(1) >>%RAMD%\DELALL.PY

python.exe %RAMD%\DELALL.PY
IF ERRORLEVEL 1 GOTO INSTBMGR
GOTO DONE

:: If we did a DISKPART CLEAN, the make sure we re-install the boot manager
:INSTBMGR
SET TESTPATH=
FOR %%I IN ("bmgr32.exe") DO SET TESTPATH=%%~dp$PATH:I
IF "%TESTPATH%" == "" SET TESTPATH=%BootDrive%\Preboot\Utils\
PUSHD %TESTPATH%
CALL BMGRINST.BAT
@ECHO ON
POPD
SET TESTPATH=

:DONE
SET DELALLDISK=
